package com.supervision.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.supervision.model.KgInfo;
import com.supervision.qanything.dto.ChatResult;
import com.supervision.service.KGService;
import com.supervision.vo.kg.ChatReqVo;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


@Slf4j
@RestController
@RequestMapping("/kg")
@RequiredArgsConstructor
public class KGController {

    private final KGService kgService;
    @ApiOperation("问答对话")
    @PostMapping("/chat")
    public ChatResult chat(@RequestBody ChatReqVo chatReqVo) {

        return kgService.chat(chatReqVo.getQuestion());
    }


    @ApiOperation("问答对话")
    @PostMapping("/hotKG")
    public IPage<KgInfo> hotKG() {

        return kgService.hotKG(new Page<>(1,10));
    }
}
