package com.supervision.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.metadata.OrderItem;
import com.baomidou.mybatisplus.core.toolkit.ObjectUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.supervision.model.KgPolicy;
import com.supervision.service.KgPolicyService;
import com.supervision.mapper.KgPolicyMapper;
import org.springframework.stereotype.Service;

/**
 * @author Administrator
 * @description 针对表【kg_policy(政策法规表)】的数据库操作Service实现
 * @createDate 2024-04-16 13:05:24
 */
@Service
public class KgPolicyServiceImpl extends ServiceImpl<KgPolicyMapper, KgPolicy>
        implements KgPolicyService {

    @Override
    public IPage<KgPolicy> queryPolicyPage(String keyword, Integer level, Integer subject, Integer type, Integer order, Integer pageNum, Integer pageSize) {
        // 排序方式 默认发文时间降序,1最多收藏降序;2最多浏览降序
        Page<KgPolicy> page = new Page<>(pageNum, pageSize);
        if (ObjectUtils.isNull(order)) {
            // 默认发文时间排序
            page.addOrder(OrderItem.desc("publish_time"));
        } else {
            if (1 == order) {
                // 收藏降序
                page.addOrder(OrderItem.desc("mark_count"));
            }
            if (2 == order) {
                // 浏览降序
                page.addOrder(OrderItem.desc("read_count"));
            }
        }

        return this.baseMapper.queryPolicyPage(keyword, level, subject, type, page);
    }
}




